=== debian/changelog ===
llvm-toolchain-snapshot (1:5.0~svn305653-1ubuntu1) artful; urgency=medium

  * Enable ocaml on all arches.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sat, 15 Jul 2017 23:14:49 +0100

llvm-toolchain-snapshot (1:5.0~svn305653-1build1) artful; urgency=high

  * No change rebuild against ocaml 4.04.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Jul 2017 15:21:51 +0100

llvm-toolchain-snapshot (1:5.0~svn305653-1) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Re-add clang-doc documentation

  [ Sylvestre Ledru ]
  * New snapshot release
  * Fix a hurd PATH_MAX issue
  * Transform the lldb swig check from a error to a warning
  * Add libomp-dev to the suggests of clang
  * Add Provides on python-lldb-x.y & python-clang-x.y & libllvm-x.y-ocaml-dev
    to avoid the recurring problem about conflicts
    (Closes: #835546, #863739, #863742)
  * Standards-Version => 4.0.0
  * Generate the llvm-tblgen, clang-change-namespace, clang-offload-bundler
    lld, clang++, clang-check, clang-cpp & clang-import-test manpages
  * Remove the --no-discard-stderr option from help2man calls
  * use -DPOLLY_BUNDLED_JSONCPP=OFF & add pkg-config as a dep (to help find
    the files)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 09 Jun 2017 12:04:56 +0200

llvm-toolchain-snapshot (1:5.0~svn302368-1~exp1) experimental; urgency=medium

  * Only enable libfuzzer for Linux kernel.
    Thanks to Pino Toscano for the patch
  * Add option -DPOLLY_BUNDLED_JSONCPP=ON
    to use the system lib instead of the patch d/p/use-deb-json.diff
  * New symbols added in libclang
     - clang_EvalResult_getAsLongLong
     - clang_EvalResult_getAsUnsigned
     - clang_EvalResult_isUnsignedInt
     - clang_TargetInfo_dispose
     - clang_TargetInfo_getPointerWidth
     - clang_TargetInfo_getTriple
     - clang_Type_isTransparentTagTypedef
     - clang_getAllSkippedRanges
     - clang_getTranslationUnitTargetInfo

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 07 May 2017 12:13:43 +0200

llvm-toolchain-snapshot (1:5.0~svn298899-1) unstable; urgency=medium

  * Limit the archs where the ocaml binding is built
    Should fix the FTBFS
    Currently amd64 arm64 armel armhf i386
  * d/p/add_symbols_versioning.patch removed (applied upstream)
  * Really fix "use versioned symbols" for llvm
    Thanks to Julien Cristau for the patch (Closes: #849098)
  * Explicit the dep of clang-tidy on same version of llvm to avoid
    undefined symbols
  * Add override_dh_makeshlibs for the libllvm or liblldb versions
    Thanks to Julien Cristau for the patch
  * change the min version of the libclang1 symbols to 1:4.0-3~
  * Fix the symlink on scan-build-py
  * add libncurses in the list of build deps (Closes: #861170)

  [ Rebecca N. Palmer ]
  * Use versioned symbols (Closes: #848368)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 09 Apr 2017 10:11:56 +0200
